#define Amp_In 33
float Current = 0;

//float APB = 0.024414;
// const float VPA = 0.04;  //Volts per ampere
// const float QOV = 0.4;   //quiescent voltage (Voltage at Vout when 0 current is flowing)
const int offsetSmoothing  = 40;
const int currentSmoothing = 50;
int       currentOffset    = 0;
float     mapb             = 34.2;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200); 

  int adcAverage = 0;
  for (int i = 0; i<offsetSmoothing; i++)
  { 
    adcAverage = adcAverage + analogRead(Amp_In);
  }
   currentOffset = adcAverage/offsetSmoothing;

}

void loop() {
  // put your main code here, to run repeatedly:
    readCurrent();
    delay(100);
    
}

void readCurrent ()
{                                        
    // float tempCurrent = (3.3/4096)*analogRead(Amp_In);                       // Read the ADC value from the current sensor (2.5V is 0A --> 5V is 150A
    // //float tempCurrent = analogRead(Amp_In); 
    // Serial.println(tempCurrent);
    // tempCurrent = tempCurrent-QOV;                                // Multiply the difference by the amps per bit value. (This must be calculated) 
    // tempCurrent = tempCurrent/VPA;
    // tempCurrent = constrain(tempCurrent,0,150);                   // Constrain so there are no error values on the LCD screen
    // Current = tempCurrent;                                          // Use the Current global variable to store the Current value   
    // //Serial.println(Current);

  int adcAverage = 0;
  for (int i = 0; i<currentSmoothing; i++)
  { 
    adcAverage = adcAverage + analogRead(Amp_In);
  }
  int tempCurrent = adcAverage/currentSmoothing;
  //Serial.print(tempCurrent);
  tempCurrent = tempCurrent - currentOffset;
  tempCurrent = constrain(tempCurrent,0,4096);
  //Serial.print("    Offset: "); Serial.println(tempCurrent);
  tempCurrent = tempCurrent * mapb;
  Serial.println(tempCurrent);
}
